# Grafana Labs' Jsonnet libraries

This repository contains various Jsonnet libraries we use at Grafana Labs:

* [`consul-mixin`](consul-mixin/): A set of reuseable and extensible dashboards
  and alerts for running Hashicorp's Consul.

* [`grafana-builder`](grafana-builder/): A library for building Grafana dashboards
  with jsonnet, following the builder pattern.

* [`ksonnet-util`](ksonnet-util/): An overlay and set of utilities aiming at making
  working with Kubernetes easier.

* [`memcached-mixin`](memcached-mixin/): A set of reuseable and extensible dashboards
  for Memcached.

* [`nodejs-mixin`](nodejs-mixin/): A set of reusable and extensible dashboards
  for Node.js.

* [`caddy-mixin`](caddy-mixin/): A set of reusable and extensible dashboards
  for Caddy.

* [`oauth2-proxy`](oauth2-proxy/): A jsonnet configuration for deploying bitly's
  OAuth proxy to Kubernetes.

* [`prometheus-ksonnet`](prometheus-ksonnet/): A set of extensible configurations
  for running Prometheus on Kubernetes.

* [`jira-mixin`](jira-mixin/): A set of reusable and extensible dashboards and alerts for JIRA.

## LICENSE

[Apache-2.0](LICENSE)
